@echo off

setlocal enableextensions enabledelayedexpansion

:CHECKHELP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP


:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:

	set bat_capturedfilesdir=%~1
	set bat_archivedfilesdir=%~2
goto :MAIN



:MAIN
	set bat_counter=0
	for /f "usebackq tokens=*" %%a in (`find /i ".bin" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		echo     copy /y "!bat_capturedfilesdir!\%%~a" "!bat_archivedfilesdir!"
		         copy /y "!bat_capturedfilesdir!\%%~a" "!bat_archivedfilesdir!"
	)
	echo.
	echo Total copied=!bat_counter!
goto :DONE



:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo     Usage: %~nx0 ^<capturedfilesdir^>  ^<archivedfilesdir^>
	echo.
	echo     This script copies each FF file mentioned in the 
	echo     "<archivedfilesdir>\FTPdetectinfo.txt" file from the 
	echo     ^<capturedfilesdir^> directory to the ^<archivedfilesdir^>
	echo     directory. 
	echo.
	echo    NOTE:
	echo     This script was created for those situations where the 
	echo     FTPdetectinfo.txt file is good, but the FF*.bin files 
	echo     in the ArchivedFiles directory are missing.  Therefore, 
	echo     this script restores the ArchivedFiles directory, but it
	echo     depends on a valid FTPdetectinfo.txt file.
	echo.
	echo     If you don't have a valid FTPdetectinfo.txt file, you will
	echo     need to re-run the MakeCaseListing.bat script in order to
	echo     rerun the Reprocess function. 
	echo.
	echo     Example: 
	echo         %~n0 "C:\CAMS\CapturedFiles\2011_12_29_10_05_15" "C:\CAMS\ArchivedFiles\2011_12_29_10_05_22"
	echo.
exit /b 9


:DONE
