  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	rem set bat_pushstring=


	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_logdir!\CreateCameraListFile.bat.log
	
	!bat_log!
	!bat_log! =============================================================
	!bat_pushlog! [!date! !time!] - %~dpnx0 %*
	!bat_log!

	call :READPARAMS

	if "%~1" equ "" (
		goto :HELP
	)

	set bat_capturedfilesdir=%~1

	call :MAIN %*
goto :DONE





	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:MAIN
!bat_pushlog! [CALL !bat_batchfile!:MAIN] "!bat_detectfile_temp!" [%*]
	set bat_retval=success
	set bat_returncode=0

	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	call :GETCAMERAFROMCAPTURED


:MAIN_END
!bat_poplog! [RETURN !bat_batchfile!:MAIN] [!bat_retval!, bat_camera_list=!bat_camera_list!]
!bat_log!
!bat_return!



:GETCAMERAFROMCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMCAPTURED] %*

	if exist "!bat_GCFC_tempfile!" (
		call :GETCAMERALIST
		goto :GETCAMERAFROMCAPTURED_END
	)

	set /a bat_capturedcount=0
	set bat_camera_temp=
	set bat_camera_prev=
	set bat_camera_list=
	set /a bat_camera_count=0
	
	if not defined bat_capturedfilesdir (
		goto :GETCAMERAFROMCAPTURED_END
	)

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d /o-n`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d /o-n`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		
		set bat_camera_temp=!bat_temp:~2,3!

		if /i "!bat_camera_prev!" neq "!bat_camera_temp!" (
			if not defined bat_camera_list (
				!bat_log! 'a        ADDING TO CAMERA LIST: "GCFC.log": !bat_temp!
				set bat_camera_list=0!bat_camera_temp!
				set bat_camera_prev=!bat_camera_temp!
				set /a bat_camera_count+=1
				echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"
			) else (
				call :CHECK_GCFC "!bat_camera_temp!"
				if not defined bat_GCFC_found (
					!bat_log! 'c        ADDING TO CAMERA LIST: "GCFC.log": !bat_temp!
					set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
					set bat_camera_prev=!bat_camera_temp!
					set /a bat_camera_count+=1
					echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"
				)
			)

			if not defined bat_camera (
				set bat_camera=!bat_camera_temp!
				!bat_log! 'b    set bat_camera=!bat_camera_temp!
			)
		)
	)
	!bat_pop!
	
	set bat_camera_list=
	!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - before...
	!bat_logexeclog! type "!bat_GCFC_tempfile!"

	!bat_log!
	!bat_logexeclog! sort "!bat_GCFC_tempfile!" /output "!bat_GCFC_tempfile!"
	!bat_log!
	!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - after...
	!bat_logexeclog! type "!bat_GCFC_tempfile!"
	
	call :GETCAMERALIST
	
:GETCAMERAFROMCAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMCAPTURED] [bat_camera=!bat_camera!, bat_camera_list=!bat_camera_list!, bat_capturedcount=!bat_capturedcount!]
!bat_log!
!bat_return!


:CHECK_GCFC
rem !bat_pushlog! [CALL !bat_batchfile!:CHECK_GCFC] [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!"`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
rem !bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
rem !bat_log!
!bat_return!





:GETCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERALIST] %*
	!bat_pushlog! call "!bat_exedir!\GetCameraList.bat" "!bat_GCFC_tempfile!"
	              call "!bat_exedir!\GetCameraList.bat" "!bat_GCFC_tempfile!"
	!bat_pop!
:GETCAMERALIST_END
!bat_poplog! [CALL !bat_batchfile!:GETCAMERALIST] [bat_camera_list=!bat_camera_list!]
!bat_return!

	set bat_camera_list=
	for /f "usebackq tokens=*" %%a in (`type "!bat_GCFC_tempfile!"`) do (
		if not defined bat_camera_list (
			set bat_camera_list=0!%%a
		) else (
			set bat_camera_list=!bat_camera_list!0%%a
		)
	)



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_log! call "!bat_exedir!\ReadParams.bat"
	          CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 " "C:\CAMS\CapturedFiles\2012_08_11_03_44_55""
	echo.
	echo Creates the GCFC.log file in the CapturedFiles directory.  The GCFC.log 
	echo file contains a list of camera numbers that are used in the 
	echo CapturedFiles dir.
	echo.
exit /b 9



:DONE
	!bat_poplog! :DONE with %~f0 %*
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log!

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		SET bat_camera_list=%bat_cameralist2%
	) ELSE ( echo.%bat_retval%)
exit /b 0