 @echo off
setlocal enabledelayedexpansion enableextensions

:SETUP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"

	!bat_pushecho! =====================================================
	!bat_echolog! [!date! !time!] %~dpnx0 %*

	set bat_targetlocation=!bat_exedir!
	set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdirfull=%~1
	
	if not defined bat_targetdirfull (GOTO :HELP)

	if "%2" neq "" set bat_detectfile=%~1\%~nx2

	call :PARSEDIR "!bat_detectfile!"
	call :PARSEDIR "!bat_retval1!"
	set bat_targetdirname=!bat_retval2!
	call :PARSEDIR "!bat_retval1!"
	set bat_targetdirbase=!bat_retval1!

goto :REPLACETEXT %*


	rem The ReplaceText.exe program was originally called FART.exe.  I renamed
	rem it so that its name would more adaquately describe its function.
:REPLACETEXT
!bat_log! [GOTO !bat_batchfile!:REPLACETEXT] %*
	!bat_log! '    bat_targetdirname=!bat_targetdirname!
	!bat_log! '    bat_targetdirbase=!bat_targetdirbase!

	set /a linecount=0
	set bat_fffolder=
	set bat_ffdirname=
	set bat_fffolder=
	set bat_ffbasepath=
	set bat_calfolder=
	set bat_calpath=

	if not exist "!bat_detectfile!" (
		!bat_echolog! '     ERROR - not exist: "!bat_detectfile!"
		set bat_returncode=1000
		goto :DONE
	)

	for /f "usebackq tokens=* skip=2" %%a in (`find /i "FF  folder" "!bat_detectfile!"`) do (
		set bat_inputline=%%~a
		set bat_fffolder=!bat_inputline:~13,600!
		set bat_fffolder=!bat_fffolder:~0,-1!
	)

	if defined bat_fffolder (
		rem Separate dirname from ArchivedFiles dir
		call :PARSEDIR "!bat_fffolder!"
		set bat_ffdirname=!bat_retval2!
		rem Separate ArchivedFiles from basepath
		call :PARSEDIR "!bat_retval1!"
		set bat_ffbasepath=!bat_retval1!
rem		set bat_outputline=!bat_targetdirbase!\ArchivedFiles\!bat_ffdirname!
		set bat_outputline=!bat_targetdirfull!
		rem echo     to      : "!bat_fffolder!"


		!bat_pushlog!
			!bat_logexeclog! call "!bat_exedir!\ReplaceText.exe" -i "!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
			set /a bat_returncode=!bat_logexec_returncode!*100
		!bat_poplog!
	)

	!bat_log! '    bat_fffolder=!bat_outputline!

	for /f "usebackq tokens=* skip=2" %%a in (`find /i "CAL folder" "!bat_detectfile!"`) do (
		set bat_inputline=%%~a
		set bat_calfolder=!bat_inputline:~13,600!
		set bat_calfolder=!bat_calfolder:~0,-1!

	)

	if defined bat_calfolder (
		rem Separate dirname from ArchivedFiles dir
		call :PARSEDIR "!bat_calfolder!"
		set bat_calpath=!bat_targetdirbase!\Cal
		set bat_outputline=!bat_targetdirbase!\Cal
		rem echo     to:     : "!bat_calpath!"

		!bat_pushlog!
			!bat_logexeclog! call "!bat_exedir!\ReplaceText.exe" -i "!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
			set /a bat_returncode=!bat_logexec_returncode!+!bat_returncode!&	rem Number of changed occurences
		!bat_poplog!
	)
	
	!bat_log! '    bat_calfolder=!bat_outputline!
	!bat_log! [END !bat_batchfile!:REPLACETEXT] goto :DONE
goto :DONE


:GETMETEORCOUNT
	set bat_retval=
	for /f "usebackq skip=2 tokens=1-20" %%A in (`find /i /c ".txt" "!bat_detectfile!"`) do (
		if /i "%%B" equ "" (set bat_retval=%%A)
		if /i "%%C" equ "" (set bat_retval=%%B)
		if /i "%%D" equ "" (set bat_retval=%%C)
		if /i "%%E" equ "" (set bat_retval=%%D)
		if /i "%%F" equ "" (set bat_retval=%%E)
		if /i "%%G" equ "" (set bat_retval=%%F)
		if /i "%%H" equ "" (set bat_retval=%%G)
		if /i "%%I" equ "" (set bat_retval=%%H)
		if /i "%%J" equ "" (set bat_retval=%%I)
		if /i "%%K" equ "" (set bat_retval=%%J)
		if /i "%%L" equ "" (set bat_retval=%%K)
		if /i "%%M" equ "" (set bat_retval=%%L)
		if /i "%%N" equ "" (set bat_retval=%%M)
		if /i "%%O" equ "" (set bat_retval=%%N)
		if /i "%%P" equ "" (set bat_retval=%%O)
		if /i "%%Q" equ "" (set bat_retval=%%P)
		if /i "%%R" equ "" (set bat_retval=%%Q)
		if /i "%%S" equ "" (set bat_retval=%%R)
		if /i "%%T" equ "" (set bat_retval=%%S)
	)
	
	set bat_meteorcount=bat_retval
!bat_return!



:GETSTRLEN [in] bat_string [out] bat_retval
	set bat_retval=
	set bat_string=%~1
	for /L %%a in (0,1,2000) do (
		if "!bat_string:~%%a,1!" neq "" (
			set /a bat_retval=%%a
		)
	)
	
	rem echo return-:GETSTRLEN [!bat_retval!, !bat_string!]
!bat_return!



	rem This routine parses out the elements of a directory or full file name
	rem and path and returns the last segment (either the filename or the last
	rem directory name) as well as the parent path. It removes the trailing 
	rem backslash from everything also.  It is designed to be called several
	rem times as needed (where you'd pass !bat_retval1! as the argument in
	rem subsequent calls) to further parse everything out. 
	rem
	rem This example will explain the two output variables:
	rem    arg1=c:\cams\archivedfiles\2012_02_07_02_43_36\
	rem    bat_retval1=c:\cams\archivedfiles
	rem    bat_retval2=2012_02_07_02_43_36
	rem
:PARSEDIR [in] c:\cams\archivedfiles\2012_02_07_02_43_36\ [out] c:\cams\archivedfiles 
!bat_pushlog! [CALL !bat_batchfile!:PARSEDIR] [in] c:\cams\archivedfiles\{datedir}\FTPdetectinfo.txt [out] c:\cams\archivedfiles{datedir}
	!bat_log! [in] "%~1"  
 
	set bat_retval=
	set bat_retval1=
	set bat_retval2=
	
	rem If the entire directory is pointing to the root drive letter of
	rem a dir, there is nothing to parse. The bat_retval1 and bat_retval2
	rem variables will be undefined.  
	if /i "%~1" equ "!bat_targetdrive!" goto :PARSEDIR_END

	set bat_retval1=%~dp1::
	set bat_retval1=!bat_retval1:\::=!
	set bat_retval1=!bat_retval1:::=!
	set bat_retval2=%~nx1

	!bat_log! [out=bat_retval1] "!bat_retval1!"
	!bat_log! [out=bat_retval2] "!bat_retval2!"
:PARSEDIR_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEDIR] [out=!bat_retval1!, !bat_retval2!]
!bat_log!
!bat_return!












:HELP
	@echo off
	echo.
	echo Usage: %~dpnx0 C:\CAMS\ArchivedFiles\2012_01_24_03_09_22 [detectfile]
	echo.
	echo This script changes the paths recorded in the FTPdetectinfo.txt 
	echo file header to the path of its current location.  The reason it is 
	echo needed is because some of the programs, such as FTP_Confirmation, 
	echo FTP_ApplyCal2detectinfo, etc. use the "FF  folder" and 
	echo "CAL folder" values from the detect file.  If you move the 
	echo original files/dirs to another place to work on them, they will 
	echo croak. This script fixes only those two lines.  It should be
	echo compatable with the FTPdetectinfo.txt files in either the ArchivedFiles
	echo or ConfirmedFiles directories.  
	echo.
	echo The optional argument [detectfile] is there in case you need to 
	echo perform these actions when the detect file is named something other
	echo than "FTPdetectinfo.txt".  For example, your detect file may be
	echo named "FTPdetectinfo_0299_2012_01_18.txt". In that case, you would
	echo use the optional 2nd command line argument to specify the detect file
	echo name. 
	echo.
	echo Examples:
	echo    call "%~dpnx0" "C:\CAMS\ArchivedFiles\2012_01_24_03_09_22"
	echo.
	echo        it will work on the FTPdetectinfo.txt file in that directory. 
	echo.
	echo    call "%~dpnx0" "C:\CAMS\ArchivedFiles\2012_01_24_03_09_22" "FTPdetectinfo_0299_2012_01_24.txt"
	echo.
	echo        it will work on the FTPdetectinfo_0299_2012_01_24.txt file.
	echo.
exit /b 9


:DONE
	!bat_pop!
	!bat_echolog! exit /b !bat_returncode!
	!bat_echolog! [!date! !time!] DONE with %~nx0 
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!
