@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	echo %~0 %*
	echo.
	if "%~1" equ "" goto :HELP


:TARGETDIR
	set bat_targetdir=%~1

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	set bat_exedir=%~dp0
	set bat_exedir=!bat_exedir:~0,-1!
	
	set bat_archivedfilesdir=!bat_targetdir!
	for /f "usebackq tokens=*" %%a in ('"!bat_targetdir!"') do (
		echo   %%~a
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
	)

	call :PARSEDIRNAME "!bat_archivedfilesdir!"
	call :PARSEDIRNAME "!bat_retval1!"
	set bat_basedir=!bat_retval1!
	set bat_caldir=!bat_retval1!\Cal
	call :PARSEDIRNAME "!bat_retval1!"
	set bat_camera=!bat_retval2!

	

	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

:MAIN

	for /f "usebackq tokens=*" %%h in (`dir "!bat_caldir!\CAL???_!bat_caldate!*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_caldir!\%%h
		echo   !bat_calfilename!
		
		for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_calfilename!"`) do (
			set bat_found=0
			if "%%h" equ " Camera number            " (set bat_found=1)
			if "%%h" equ " Calibration date         " (set bat_found=1)
			if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
			if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
			if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
			if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
			if "%%h" equ " Mean O-C " (
				set bat_found=1
				echo  %%h                 =%%i
			) else (
				if !bat_found! equ 1 (
					echo  %%h =%%i
				)
			)
		)
		set /a bat_calfilestars=0
		for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (

			set /a "bat_calfilestars=%%j-56"
		)
		echo   Cal stars used            = !bat_calfilestars!
		echo.
	)


goto :DONE

:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
	)
	echo.
	


	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
	ECHO :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%%~a"
		) else (
			set bat_string=!bat_string!+"%%~a"
		)
	)
	echo     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"
	         copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	echo :GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\FTPdetectinfo.txt"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!


	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
echo :REBUILDHEADER
	set /a bat_linecount=0
	echo     for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo     Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo     !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo     !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo     %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:CONCATFINAL
	echo     copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"
	         copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"



	del "!bat_outputfile!"
	echo.
	if not exist "!bat_targetdir!\FTPdetectinfo.txt" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command:
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

	echo.
	echo     Date/Time           Size           File name
	echo     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		echo     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	echo.

	echo    Excerpt from "!bat_targetdir!\FTPdetectinfo.txt", please review the
	echo    information obtained from the "!bat_targetdir!\FTPdetectinfo.txt" file: 
	echo       - Meteor Count   [should be !bat_count!]
	echo       - FF folder      [should be "!bat_targetdir!"]
	echo       - CAL folder     [should match the drive and dir where your Cal files are stored]
	echo       - Cal file       [May not be correct, if not, Don't skip the Apply process]
	echo.
	echo    Please wait while opening and displaying the first 14 lines from 
	echo    the "!bat_targetdir!\FTPdetectinfo.txt" file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			echo         %%a
		) else (
			if !bat_counter! equ 15 (
				echo.
				echo     Please wait while skipping the rest of the file... [!time!]
			)
		)
	)

:CONCATDISPLAY


:VALIDATE01B
	echo.
	echo.
	echo    The Cal file's date/time might be from a different date, depending on
	echo    where you are in the process or how many times you have gone through the
	echo    process.  The Cal file's date/time is showing the date/time of a recent
	echo    calibration, which may be a previous day.  
	echo.
goto :DONE


:PARSEDIRNAME [in path] [out] bat_retval1 bat_retval2
	rem bat_retval1=basedir (dp)
	rem bat_retval2=dirname (nx)
	
	set bat_retval1=%~dp1
	set bat_retval1=!bat_retval1:~0,-1!
	set bat_retval2=%~nx1
	
		
GOTO :EOF




:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Merge the multiple file created by MakeCaseListing.bat,
	echo          such as FTPdetectinfo_CaseHeader.txt plus the multiple 
	echo          FTPdetecinfo_Case_001,002... files into a single
	echo          FTPdetectinfo.txt file.
exit /b



:DONE

