
	!bat_pushlog! [CALL RedirectLogs.bat] [%*]
		!bat_log! Before redirecting, the Current bat_logdir=!bat_logdir!
		!bat_log! Before redirecting, the Current bat_logfile=!bat_logfile!
		!bat_log! Before redirecting, the Current bat_logfile_full=!bat_logfile_full!
		
		!bat_logexeclog! set bat_redirect=%~1
		if /i "!bat_redirect:~0,1!" equ "_" (
			rem If the first character is "_", then bad parameters were given. In that
			rem case, it will default to the "..\Logs" dir for safe keeping. 
			rem Likewise, if there are no arguments, then it will default to 
			rem the "..\Logs" dir

			!bat_logexeclog! set bat_redirect=
		)
	
		if /i "!bat_redirect!" equ "" (
			rem If no arguments, then the "!CD!\Logs" dir is the default. 
			!bat_logexeclog! set bat_logdir=!CD!\Logs
		) else (
			if /i "%~2" neq "" (
				rem If there is a 2nd argument, then the 2nd argument is used as the
				rem base directory and the log directory will be a subdir under that.
				rem This is used for when running scripts after the session has been
				rem moved to the "^<bat_submissionfilesdir^>". 

				set bat_captureddatetime=%~1
				set bat_captureddate=!bat_captureddatetime:~0,10!
				set bat_capturedtime=!bat_captureddatetime:~-8!
				!bat_logexeclog! set bat_redirect=%~2
				!bat_logexeclog! set bat_logdir=%~2\Logs
			) else (
				!bat_log! Redirecting the new log directory to...
				!bat_logexeclog! set bat_logdir=!CD!\Logs\!bat_redirect!
			)
		)
		
		!bat_log! Redirecting the other log settings to...
		!bat_logexeclog! set bat_logfile=!bat_logdir!\!bat_logfile_name!.log
		!bat_logexeclog! set bat_logfile_full=!bat_logdir!\AutoCams_full.log

		if not exist "!bat_logdir!" (
				!bat_logexeclog! md "!bat_logdir!"
		)


		!bat_pushlog! Moving "!CD!\Logs\*.*" to the new log dir...
			!bat_log!     move /y "!CD!\Logs\*.*" "!bat_logdir!"
			for /f "usebackq tokens=*" %%X in (`dir "!CD!\Logs\*.*" /b /a-d /on `) do (
				!bat_log! !bat_logdir!\%%X
				if exist "!bat_logdir!\%%X" (
					if /i "!bat_logdir!\%%X" neq "!CD!\Logs\%%X" (
						!bat_logexeclog! copy "!bat_logdir!\%%X"+"!CD!\Logs\%%X" "!bat_logdir!\%%X"
						del /q "!CD!\Logs\%%X"
					)
				)
			)

			!bat_logexeclog! move /y "!CD!\Logs\*.*" "!bat_logdir!"
			!bat_log! Note: The [move /y "!CD!\Logs\*.*" "!bat_logdir!"] header is missing due to logfile change
		!bat_poplog!

		!bat_pushlog! Moving "!CD!\Logs\!bat_redirect!\*.*" to the new log dir... 
			!bat_log! move /y "!CD!\Logs\!bat_redirect!\*.*" "!bat_logdir!"
			for /f "usebackq tokens=*" %%X in (`dir "!CD!\Logs\!bat_redirect!\*.*" /b /a-d /on `) do (
				!bat_log! !bat_logdir!\%%X
				if exist "!bat_logdir!\%%X" (
					if /i "!bat_logdir!\%%X" neq "!CD!\Logs\!bat_redirect!\%%X" (
						!bat_logexeclog! copy "!bat_logdir!\%%X"+"!CD!\Logs\!bat_redirect!\%%X" "!bat_logdir!\%%X"
						del /q "!CD!\Logs\!bat_redirect!\%%X"
					)
				)
			)

			!bat_logexeclog! move /y "!CD!\Logs\!bat_redirect!\*.*" "!bat_logdir!"
			!bat_log! Note: The [move /y "!CD!\Logs\!bat_redirect!\*.*" "!bat_logdir!"] header is missing due to logfile change
		!bat_poplog!

		set bat_redirect=&	rem delete the temporary variable

	!bat_poplog! [RETURN-RedirectLogs.bat] [bat_logdir=!bat_logdir!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
goto :DONE

:HELP
	echo.%~0
	echo.
	echo.Usage: %~0 ^<date^> "^<new.log.dir^>"
	echo.
	echo.Example:
	echo.   %~0 2013_03_17_02_51_48 "C:\CAMS\SubmissionFiles\2013_03_17_02_51_48\213\Logs\2013_03_17_02_51_48"
	echo.
	echo.If date is missing, it will default to the "!CD!\Logs" directory. 
	echo.If the "^<new.log.dir^>" is missing, it will assume "!CD!\Logs\^<date_time^>". 
	echo.
	echo.If there are two arguments, it is assumed that it is running from the 
	echo.^<bat_submissionfilesdir^> and that the ^<bat_capturedtime^> variable is passed
	echo.as the first argument.  
	echo.
goto :DONE
	
:DONE
exit /b 0