@echo off
setlocal ENABLEDELAYEDEXPANSION ENABLEEXTENSIONS

set return=goto :EOF

set retval=0

set bat_countarchived=%~1
set bat_submissiondir=%~dpnx2
set bat_emailfilesdir=!bat_submissiondir!\EmailFiles
set bat_dirname=%~3
set bat_camera=%~4
set bat_sourcefile=%~5

:MAIN
	set bat_countconfirmed=0
	set bat_countscanned=0
	
	call :STRIPHEADER bat_countarchived "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "!bat_sourcefile!"
%return%


:STRIPHEADER
echo :STRIPHEADER %*
	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.

echo %1=!%1!
	echo     Stripping header to: "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0
	set /a bat_countevent=0
	
	set /a bat_remain=0
	TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d

	echo     for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`)
	echo     This step may take along time, please be patient...
	for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`) do (
		set bat_linebuf=%%d
		set /a bat_countscan+=1
			title ccccc !bat_countscan!  %%d
		if "!bat_countscan!" equ "1" (
			call :GETMETEORCOUNT  %1 %%~d
			if exist "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt" (
				del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
			)
			TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
		) else (
			title aaaa %%d
			if !bat_countscan! GTR 11 (
				echo %%d>>"!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
				if /i "!bat_linebuf:~0,6!" equ "FF!bat_camera!_" (
					set /a bat_countevent+=1
					set /a bat_remain=!%1!-!bat_countevent!
					TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
				)
			)
			title bbbb %%d
		)
			title ccccc %%d
	)
	
%return%




:GETMETEORCOUNT
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
echo :GETMETEORCOUNT %* [!%1!]
%return%	


:HELP
	echo Usage Example: stripheader 392  "c:\CAMS\SubmissionFiles\2011_08_11_213_02_00_13\998" "2011_08_11_02_00_13" "998" "scanned"
	echo.
	echo.    arg1=archived count      [e.g. 392]
	echo.    arg2=Submission Dir      [e.g. C:\CAMS\SubmissionFiles\2011_08_11_998_02_54_01\998]
	echo.    arg3=dirname             [e.g. 2011_08_11_]
	echo.    arg4=camera              [e.g. 998]
	echo.    arg5=sourcefile          [e.g. scanned or confirmed]
	echo.
goto :DONE


:DONE
exit /b !retval!
