@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"

	!bat_pushecho! =============================================================
	!bat_echolog! %~0 [%*]
	set /a bat_count=0

	call :READPARAMS
	call :READCONFIG


	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!

	set bat_skipoption=
	set bat_decimationfactoroption=
	set bat_choice=

	if /i "%~1" neq "" (
		rem The user specified a source directory so don't ask the directory
		set bat_targetdir=
		call :TEST1 %*
	) else (
		rem The user didn't specify a source directory, so ask which of the thre directories to process
	)

	set bat_skip=
	set bat_decimationfactor=

	call :THUMBNAILS

goto :DONE




:TEST1
	if /i "%~1" equ "" goto :TEST_END
	set /a bat_count+=1

	if /i "%~1" equ "/archiveddir" (
		set bat_archivedfilesdir=%~2
		set bat_targetdir=%~1
		set bat_choice=a
		!bat_echolog! bat_archivedfilesdir="!bat_archivedfilesdir!"
		shift
		shift
		goto :TEST1
	) else (
			if /i "%~1" equ "/captureddir" (
			set bat_capturedfilesdir=%~2
			set bat_targetdir=%~1
			set bat_choice=c
			!bat_echolog! bat_capturedfilesdir="!bat_capturedfilesdir!"
			shift
			shift
			GOTO :TEST1
		) else (
			if /i "%~1" equ "/confirmeddir" (
				set bat_confirmedfilesdir=%~2
				set bat_targetdir=%~1
				set bat_choice=f
				!bat_echolog! bat_confirmedfilesdir="!bat_confirmedfilesdir!"
				shift
				shift
				GOTO :TEST1
			)
		)
	)
	
	if /i "%~1" equ "/skip" (
		set bat_skipoption=%~2
		!bat_echolog! set bat_skipoption=!bat_skipoption!
		
		shift
		shift
		goto :TEST1
	)
	
	if /i "%~1" equ "/factor" (
		set bat_decimationfactoroption=%~2
		!bat_echolog! set bat_decimationfactoroption=!bat_decimationfactoroption!
		shift
		shift
		goto :TEST1
	)
	

:TEST_END
!bat_return!


	rem 70u. Thumbnails / Contact Sheet
	rem      test example:
	rem        cls&call "thumbnails.bat" /skip=14 /archiveddir="c:\cam213\CAMS\SubmissionFiles\2013_05_02_213_03_37_47\213\ArchivedFiles\2013_05_02_03_37_47" /factor=4
:THUMBNAILS
	!bat_pushlog! [CALL :THUMBNAILS] [%*]
	setlocal enableextensions enabledelayedexpansion

:THUMBNAILS1
	if not defined bat_targetdir (
		echo.
		echo.!bat_pushstring!Using the date/time from:
		echo.!bat_pushstring!      !bat_capturedfilesdir!
		echo.!bat_pushstring!      !bat_archivedfilesdir!
		echo.!bat_pushstring!      !bat_confirmedfilesdir!
		echo.
		set bat_choice=
		set /p bat_choice=.!bat_pushstring!Which directory to process [A]rchivedFiles, [C]apturedFiles, Con[f]irmedFiles, or [Q]uit [default=C]? 
		echo.Choice=[!bat_choice!]
		if /i "!bat_choice!" equ "q" (goto :THUMBNAILS_END)
		if /i "!bat_choice!" equ "" (set bat_choice=c)
	)
	
	set /a bat_skip=1
	

	set /a bat_count=0
	if /i "!bat_choice!" equ "a" (
		set bat_choice=!bat_archivedfilesdir!
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\ff*.bin" /b /a-d /on`) do (
			set /a bat_count+=1
		)
	) else (
		if /i "!bat_choice!" equ "c" (
			set bat_choice=!bat_capturedfilesdir!
			for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\ff*.bin" /b /a-d /on`) do (
				set /a bat_count+=1
			)
			echo.
			call :SKIPPEDFRAMES nopause
			echo.

			rem Determine the skip factor...If there are fewer than 300 files, list each.
			rem Otherwise, divide so that it skips a max of every 2 minutes
			set /a bat_temp1=!bat_count! * 10 / !bat_CAPTURE.number.of.cameras!
			!bat_echo! set /a bat_temp1[!bat_temp1!]=!bat_count! * 10 / !bat_CAPTURE.number.of.cameras!
			if !bat_temp1! gtr 3000 (
				!bat_logexec! set /a bat_skip=14
			)
		) else (
			if /i "!bat_choice!" equ "f" (
				set bat_choice=!bat_confirmedfilesdir!
				for /f "usebackq tokens=*" %%a in (`dir "!bat_confirmedfilesdir!\ff*.bin" /b /a-d /on`) do (
					set /a bat_count+=1
				)
			) else (
				goto :THUMBNAILS1
			)
		)
	)

	
	set bat_tempdir=!bat_choice!

	if defined bat_decimationfactoroption (
		set bat_decimationfactor=!bat_decimationfactoroption!

	) else (
		set bat_decimationfactor=2
	)

	if defined bat_skipoption (
		set bat_skip=!bat_skipoption!
	)

	!bat_echolog! start /w "" "!bat_exedir!\FTP_Thumbnails.exe" "!bat_tempdir!" !bat_decimationfactor! !bat_skip!
	              start /w "" "!bat_exedir!\FTP_Thumbnails.exe" "!bat_tempdir!" !bat_decimationfactor! !bat_skip!
	set bat_returncode=!errorlevel!
	!bat_echo! bat_returncode=!bat_returncode!
	
	if /i "!bat_returncode!" neq "0" (
		!bat_echolog! '    ERROR - FTP_Thumbnails.exe Failed 
		!bat_echolog! '            [returncode=!bat_returncode!] - Check if there are no FF*.bin files.
		!bat_echolog!
		goto :THUMBNAILS1
	)
	
	call :THUMBNAIL_PREVIEW "!bat_tempdir!"
	
:THUMBNAILS2
	!bat_popecho! [GOTO :THUMBNAILS2] [%*]
	!bat_echo!
	!bat_echo!
	set bat_choice=
	set /p bat_choice='!bat_pushstring![K]eep or [D]elete the files? [D] 
	!bat_echo! [!bat_choice!]

	if /i "!bat_choice!" equ "" set bat_choice=d
	if /i "!bat_choice!" equ "k" (goto :THUMBNAILS_END)

	if /i "!bat_choice!" equ "d" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`) do (
			!bat_logexec! del /q "!bat_tempdir!\%%a"
		)
		goto :THUMBNAILS_END
	)
	goto :THUMBNAILS2
	


	rem NEEDS:
	rem - Additional processing to determine if there are new .bmp files in the directory.  
	rem   Either that or scan the output and look for "Writing camera" or ".bmp".
	rem   - Check whether there is/are already .bmp files in the directory.  They will be 
	rem     overwritten, so you'll need to check the date/time stamp on the file to determine
	rem     if they are new.
	rem   - Another option is to ask the user if they would like to watch it work or to
	rem     work in the background.  If it uses bat_logexeclog, the user won't see the 
	rem     scrolling output until it is all done.  This may not be a bad thing since a lot
	rem     of text scrolls.  It might be best to filter the output by omitting the individual files
	rem     somehow (omitting "Pulling snapshort for file ...")
	rem - Ask the user if they would like to open the files for viewing?
	rem - Add menu items to open the .bmp files for viewing again after already built. (like 70a or 70v)

:THUMBNAILS_END
!bat_poplog! [RETURN !bat_batchfile!:THUMBNAILS] []
!bat_log!
ENDLOCAL
!bat_return!




:THUMBNAIL_PREVIEW
	!bat_pushlog! [CALL :THUMBNAIL_PREVIEW %*]
	setlocal enableextensions enabledelayedexpansion
	
	if /i "%~1" equ "" goto :THUMBNAIL_PREVIEW_END

	set bat_tempdir=%~1
	
	if not exist "!bat_tempdir!\Thumbnails*.bmp" (
		!bat_echo! '    ERROR - No matching files exist: [!bat_tempdir!\Thumbnails*.bmp]
		!bat_echo!
		!bat_logexec! dir "!bat_tempdir!\Thumbnails*.bmp" /s/b
		!bat_echo!
		goto :THUMBNAIL_PREVIEW_END
	)
	
:THUMBNAIL_PREVIEW2
	!bat_echo!
	!bat_echo!
	set /a bat_count=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /s/b /a-d /on`) do (
		set /a bat_count+=1
		!bat_echo! !bat_count!. %%~tzfa
	)
	!bat_echo!
	
	set bat_choice=
	!bat_log! set /p bat_choice='!bat_pushstring!Choose the file to display, or [Q]uit: 
	          set /p bat_choice='!bat_pushstring!Choose the file to display, or [Q]uit: 
	if defined bat_choice (
		if /i "!bat_choice!" equ ""  (
			goto :THUMBNAIL_PREVIEW_END
		)
		
		if /i "!bat_choice!" equ "q" (
			goto :THUMBNAIL_PREVIEW_END
		)

		if !bat_choice! gtr 0 (
			if !bat_choice! leq !bat_count! (
				set /a bat_count=0
				for /f "useback tokens=*" %%a in (`dir "!bat_tempdir!\Thumbnails*.bmp" /b /a-d /on`) do (
					set /a bat_count+=1
					if !bat_choice! equ !bat_count! (
						!bat_echolog! start /w "" "!bat_tempdir!\%%a"
									  start /w "" "!bat_tempdir!\%%a"
					)
				)
			)
		)
		
		goto :THUMBNAIL_PREVIEW2
	) else (
		goto :THUMBNAIL_PREVIEW_END
	)
	



:THUMBNAIL_PREVIEW_END
!bat_popecho! [RETURN !bat_batchfile!:THUMBNAIL_PREVIEW] [!bat_returncode!]
!bat_log!
ENDLOCAL
!bat_return!





	rem 6. SkippedFrames ******************************************
	rem    Lists the skipped frames and produces a summary.  The summary is 
	rem    saved in the current bat_logfile. 
:SKIPPEDFRAMES
	if /i "%~1" equ "" (set bat_args=) else (set bat_args=/v /ok) 
	!bat_echolog! call "!bat_exedir!\skippedFrames.bat" /camera !bat_camera! "!bat_capturedfilesdir!"
	              call "!bat_exedir!\SkippedFrames.bat" /camera !bat_camera! "!bat_capturedfilesdir!"

:SKIPPEDFRAMES_END
	if /i "%~1" equ "" (pause)
!bat_log!
!bat_return!







:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_retval=failed
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_push!
	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		set bat_retval=success
		set bat_temp=%%x
							rem if /i "%%x" neq "[CAMSMENU]" (
							rem      set %%x
							rem )

		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq "rem" (
							rem It's not a single line comment "rem"

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
									set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
									rem !bat_log! '    set !bat_temp!
												   set !bat_temp!
									) else (
											rem It's a key=value
											set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
	)
	!bat_pop!

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [AutoCams.bat.ini=!bat_retval!, "!bat_capturedfilesdir!"]
!bat_log!
!bat_return!



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!







:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0 [/^<type^>="<sourcedir>"] [/skip=n] [/factor=n]
	echo.
	echo.  ^<type^>        Optional - specify either:
	echo.                    /archiveddir
	echo.                    /captureddir
	echo.                    /confirmeddir
	echo.  ^<sourcedir^>   The full path to the source directory
	echo.  /factor       Specify a resample rate ^> 0 where 1 is full resolution
	echo.
	echo.                  Note: The smaller the resample rate, the larger the 
	echo.                        thumbnail files.
	echo.  /skip         Specify 1-n ^(7.1 FF files per minute with NTSC, 6 for PAL^)
	echo.
	echo.                  Note: Using a small number on the CapturedFiles directory
	echo.                        take more time and produce larger thumbnail files.
	echo.
	echo.  Generates thumbnails from the specified directory.  If no directory is 
	echo.  specified, then the user will be prompted for which directory to use as the 
	echo.  source.
	echo.
	echo.  If nothing is specified on the command line, the three possible source directories
	echo.  are determined by reading the "AutoCams.bat.ini" file to determine the 
	echo.  date/time to use. 
	echo.
	echo.  In the case that CapturedFiles is the source directory and if no
	echo.  /skip value is provided as a command-line option, the skip count will
	echo.  be adjusted to skip every two minutes, unless the number of files in the
	echo.  CapturedFiles dir is fewer than 300, in which case the skip count is set to
	echo.  "1" [where "1" adds each file in the dir to the thumbnail]
	echo.
	echo.  The default decimation factor is 2x (or half resolution), which produces
	echo.  file. You can override this default using the following additional command
	echo.  line argument:
	echo.      /factor=n
	echo.
	echo.  Where "n" is a positive whole number greater than 0
	echo.
	echo.  Examples:
	echo.      "%~0" 
	echo.
	echo.        Will offer the user the choice of creating thumbnails for either:
	echo.          ArchivedFiles, CapturedFiles, or ConfirmedFiles.
	echo.
	echo.      "%~0" /archivedir="C:\CAMS\ArchivedFiles\2013_08_11_04_32_11" /factor=2 /skip=1
	echo.
	echo.        Will create the thumbnails from the FF*.bin files in the ArchivedFiles
	echo.        directory.  It will skip no files and resample at 1:2.
	echo.
	echo.      "%~0" /factor=4 /skip=14
	echo.
	echo.        Will offer the user the choice of source directory and then it
	echo.        will create the thumbnails from the FF*.bin files in the selected
	echo.        directory using an image resample rate of 1:4 .  It will skip 
	echo.        every 2 minutes.  
	echo.
	echo.
	echo.  WEATHER CHECK:
	echo.    A good way to do a quick weather check is with /skip=70 [every 10 minutes) with
	echo.    very low resolution /factor=8 [thus small bitmap file]. Of course, you could
	echo.    choose either the CapturedFiles or ArchivedFiles directory for this.
	echo.
	echo.  FIREBALL SCAN:
	echo.    The only way to really do a fireball scan is to scan the CapturedFiles 
	echo.    directory instead of the ArchivedFiles or ConfirmedFiles diretories.
	echo.    This is because some fireballs are so bright that they are not detected
	echo.    in the normal meteor scan routine.  For this, you'd need to use
	echo.    /skip=1 and set /factor= to whatever yields a resolution good enough
	echo.    to distinguish a fireball from an airplane.
	echo.    Note: Typically a fireball won't span more than two image files, where
	echo.          an airplane will span several.
	echo.
exit /b 9

	Flowchart:

	New as of: 05/04/2013:

	Needs:
		- 
	
:ABORT
	!bat_poplog! '    ABORTING
	!bat_echolog! '    bat_returncode=!bat_returncode!
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
	pause
exit /b !bat_returncode!

:DONE
	!bat_poplog!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!
