

	rem This script is a subroutine that must be called from another script that 
	rem already has the following variables defined:

	rem This routine logs the output of a command by running it
	rem within a loop
:LOGEXECLOG 
	rem [out] !bat_logexec_returncode!
 
	!bat_log! [!bat_batchfile!:LOGEXECLOG] %*
	!bat_push!
	
	set bat_logexec_returncode=
	set bat_errorlevel=
	set bat_logexec_padding=                         

	if "!bat_logdir!" equ "" (
		set bat_logdir=Logs
	)

		rem The [`%*`] actuall executes the command.  The output
		rem from the command is queued into a buffer until the
		rem command is complete.  Then, the for loop echologs
		rem that output at the current indent level.
	
	set /a bat_logexeclog_counter=0
:LOGEXECLOG2
	set bat_logexeclog_log=!bat_logdir!\indent_logexeclog.bat.!bat_logexeclog_counter!.log
	if exist "!bat_logexeclog_log!" (
		set /a bat_logexeclog_counter+=1
		goto :LOGEXECLOG2
	)

	rem Handling nested calls
	%*>>"!bat_logexeclog_log!" 2>&1

	set bat_logexec_returncode=!errorlevel!
	if defined bat_errorlevel (
		set bat_logexec_returncode=!bat_errorlevel!
		!bat_log! bat_errorlevel=!bat_errorlevel!
	)

	if exist "!bat_logexeclog_log!" (
		for /f "usebackq tokens=1* delims=]" %%V in (`find /n /v "" ^< "!bat_logexeclog_log!"`) do (
			rem echo.!bat_logexec_padding!!bat_pushstring!%%W>>"!bat_logfile!"
			echo.!bat_logexec_padding!!bat_pushstring!%%W>>"!bat_logfile!"
			echo.!bat_logexec_padding!!bat_pushstring!%%W>>"!bat_logfile_full!"
		)

	    del "!bat_logexeclog_log!" 2>&1
	    set /a bat_logexeclog_counter-=1
	)
	
	rem !bat_log! bat_logexec_returncode=!bat_logexec_returncode!

:LOGEXECLOG_END
!bat_pop!
!bat_log! [RETURN-!bat_batchfile!:LOGEXECLOG] [bat_logexec_returncode=!bat_logexec_returncode!] [%*]
!bat_log!
	set bat_logexec_padding=
rem !bat_pause! [RETURN-!bat_batchfile!:LOGEXECLOG] [bat_logexec_returncode=!bat_logexec_returncode!] [%*]
!bat_return!



