@echo off
echo %~f0     version 3.1.0
setlocal enabledelayedexpansion enableextensions

    rem :SETUP then does a GOTO :MAIN
goto :SETUP


    rem Called by the :SETUP routine like this:
    rem    GOTO :MAIN !md5_newcmdline!
:MAIN
    CALL :MAIN2 !md5_newcmdline!
goto :DONE

    rem Called by the :MAIN routine like this:
    rem     CALL :MAIN2 !md5_newcmdline!
:MAIN2
  call :DOLEGACYWORK %*
%return%


    rem Called like this:
    rem    call :DOLEGACYWORK %*
:DOLEGACYWORK
rem echo off

echo =======%*==========
  if {%1} == {} (
      set sources=*.*
  ) else (
      set sources=%*
  )
  if EXIST "md5.output.txt" (
    del md5.output.txt
  )

GOTO :DOLEGW2 !sources!
rem   GOTO :DOLEGW2 a b c d

  rem Loop through command line choices
:DOLEGW2
  if {%1} == {} goto :DOLEGW3
  	  SET SOURCES=%1
	  set /a count=0
	  if exist !sources! (
		  for /f "usebackq delims=<|>" %%a in (`dir !sources! /b /a-d`) do (
		    set md5_formatsize_output=%3
		    call :FORMATSIZE "%%~za" "%%~a"
		    set out2=                         [!md5_filesize_output!]
		    set out3=!out2:~-21!
		    echo !out3!   "md5" "%%~a"
		    rem echo "!md5_arg0path!md5" "%%~a"
		    "!md5_arg0path!md5" "%%~a">>md5.output.txt
		    set /a count+=1
		  )
		  if !count! neq 0 call :COPYBATCHFILES "%cd%"
          )
  SHIFT
  goto :DOLEGW2

:DOLEGW3
  title "%~n0 done %time%"

%return%


:COPYBATCHFILES
  set save_dir=%~1
  set save_drive=%~d1
  set save_fullpath=%~f1
  set save_batch_dir=!md5_arg0path!
  set save_batch_dir=%save_batch_dir:~0,-1%
  rem set save

  if "%save_batch_dir%" neq "%cd%" (
    echo Copying the md5 utility files to "%cd%"...
    xcopy "%save_batch_dir%\md5build.bat" "." /Y/f/c >nul:
    xcopy "%save_batch_dir%\md5check.bat" "." /Y/f/c >nul:
    xcopy "%save_batch_dir%\md5checkRepeatDirs.bat" "." /Y/f/c >nul:
    xcopy "%save_batch_dir%\md5.exe" "." /Y/f/c >nul:
    xcopy "%save_batch_dir%\md5readme.txt" "." /Y/f/c >nul:
  )
%return%

:FORMATSIZE
    set md5_filesize=
    set md5_filesize_output=
    set md5_filesize_outputDecG=
    set md5_filesize_outputDecM=
    set md5_GB=
    set md5_KB=
    set md5_MB=
    set md5_remainderGB=
    set md5_remainderMB=
    set md5_temp1=
    set md5_temp2=

    set md5_filesize=%1
    set md5_filesize_output=%1 bytes
    set /a md5_temp1=!md5_filesize!-0
    
    set md5_GB=0
    set md5_MB=0
    set md5_KB=0
    
    if !md5_temp1! LSS 0 (
        set md5_GB=!md5_filesize:~0,1!
        set md5_remainderGB=!md5_filesize:~-9!
    ) else (
        set /a md5_GB=!md5_filesize!/1024/1024/1024
        set /a md5_remainderGB=!md5_filesize!-!md5_GB!*1024*1024*1024
    )

    set /a md5_MB=!md5_remainderGB!
    set /a md5_MB/=1024*1024
    set /a md5_remainderMB=!md5_remainderGB!-(!md5_MB!*1024*1024)
    
    set /a md5_KB=!md5_remainderMB!/1024*1000/1024
    
    set /a md5_temp1=!md5_remainderGB!/1024*1000
    set /a md5_temp1/=1024*1024
    set md5_temp2=000!md5_temp1!
    set md5_filesize_outputDecG=!md5_temp2:~-3!
    
    set /a md5_temp1=!md5_remainderMB!/1024*1000/1024
    set md5_temp2=000!md5_temp1!
    set md5_filesize_outputDecM=!md5_temp2:~-3!
    
    if !md5_GB! GTR 0 (
        set md5_filesize_output=!md5_GB!.!md5_filesize_outputDecG! GB
    ) else (
        if !md5_MB! GTR 0 (
            set md5_filesize_output=!md5_MB!.!md5_filesize_outputDecM! MB
        ) else (
            if !md5_KB! GTR 0 (
                set md5_filesize_output=!md5_KB! KB
            )
        )
    )
  set FILESTR="%~2" [!md5_filesize_output!]
  Title Reading %FILESTR%...
  
%return%



rem =================================================
rem Future enhancements................
rem 
:DOWORK
  @echo This can take several minutes, please wait...
  set md5_restoredir=!cd!
  rem  del !md5_outputfile!
  
:DOWORKLOOP
  if {%1} equ {} (
    %return%

  set md5_current_filespec=%~1
  shift

  call :DOELEMENT !md5_current_filespec!
  goto :DOWORKLOOP
  

:DOELEMENT
  set md5_current_dir=%~dp1
  cd /d !md5_current_dir!
  
%return%



rem :DOWORK
    @echo This can take several minutes, please wait...
    del !md5_outputfile!
    
    if /I {!md5_subdir!} == {true} (
        call :DOSUBDIR
    ) else (
        if /I {%md5_listmode%} == {true} (
            call :DOLISTFILE
        ) else (
            call :DOCURRENTDIR
        )
    )
%return%


:DOCURRENTDIR
  call :COPYBATCHFILES "%cd%"
  if {%1} == {} (
      @echo %cd%^>"!md5_arg0path!md5" -omd5.output.txt *.*
      "!md5_arg0path!md5" -omd5.output.txt *.*
  ) else (
      @echo %cd%^>"!md5_arg0path!md5" -omd5.output.txt %*
      md5 -omd5.output.txt %*
  )
%return%


:DOSUBDIR
    set md5_currentdir=%cd%
    if /I {%md5_listmode%} == {false} (
        for /R "usebackq" %%a in ("%md5_listfilespec%") do (
            cd "%%~a"
            call :DOCURRENTDIR "%md5_listfilespec%"
        )
    ) else (
        @echo ERROR - /List mode and /Subdir mode are mutually exclusive.
    )
    
    cd "%~md5_currentdir%"
%return%


:DOLISTFILE
    if /I {%md5_subdir%} == {false} (
        for /F "usebackq" %%a in ("%md5_listfilespec%") do (
            call :DOREADLISTFILE "%%a"
    ) else (
        @echo ERROR - /List mode and /Subdir mode are mutually exclusive.
        )
    )
%return%



:DOREADLISTFILE
    for /F "usebackq" %%b in ("%~1") do (
        call :DOHASHONEFILE "%%~b" %%~zb
    )
%return%


:DOHASHONEFILE
    Title Hashing "%~1" [%2 bytes]...
    @echo "!md5_arg0path!md5" "%~1" ^>^>%md5_outputfile%
    "!md5_arg0path!md5" "%~1" >>%md5_outputfile%
%return%




:SETQUIETMODE
    if /I {%md5_arg1%} == {/Q} ( set md5_quiet=true)
    if /I {%md5_arg2%} == {/Q} ( set md5_quiet=true)
    if /I {%md5_arg3%} == {/Q} ( set md5_quiet=true)
    if /I {%md5_arg4%} == {/Q} ( set md5_quiet=true)
%return%


:SETSUBDIR
    if /I {%md5_arg1%} == {/S} ( 
        set md5_subdir=true
        set md5_listfilespec=%md5_arg2%
    )
    if /I {%md5_arg2%} == {/S} ( 
        set md5_subdir=true
        set md5_listfilespec=%md5_arg3%
    )
    if /I {%md5_arg3%} == {/S} ( 
        set md5_subdir=true
        set md5_listfilespec=%md5_arg4%
    )
    if /I {%md5_arg4%} == {/S} ( 
        set md5_subdir=true
        set md5_listfilespec=%md5_arg5%
    )
    
    if /I {%md5_listfilespec%} == {} (set md5_listfilespec=*.*)
%return%


:SETLISTMODE
    if /I {%md5_arg1%} == {/L} ( 
        set md5_listmode=true
        set md5_listfilespec=%md5_arg2%
    )
    if /I {%md5_arg2%} == {/L} ( 
        set md5_listmode=true
        set md5_listfilespec=%md5_arg3%
    )
    if /I {%md5_arg3%} == {/L} ( 
        set md5_listmode=true
        set md5_listfilespec=%md5_arg4%
    )
    if /I {%md5_arg4%} == {/L} ( 
        set md5_listmode=true
        set md5_listfilespec=%md5_arg5%
    )
%return%






:DISPLAYRESULTS
    if /I {%md5_quiet%} == {true} (
        type "%md5_outputfile%"
        rem start /w wait 10
    ) else (
        @echo.
        @echo Press ENTER to edit the md5.output.txt file with notepad to remove any unwanted items.
        pause
        start notepad "%md5_outputfile%"
    )
%return%


:SETUP
  if {%~1} == {?} goto :HELP
  if {%~1} == {/?} goto :HELP
  if {%~1} == {-h} goto :HELP
  if {%~1} == {/h} goto :HELP

    :: This setting allows for loop late expression evaluation.
    :: It also limits the scope for new environment variables
    :: to this batch file!!!!  No need to clean up variables
    :: when finished!!! Also, no need to worry about ENV variable
    :: conflicts.
    SETLOCAL ENABLEEXTENSIONS
    if errorlevel 1 (
        echo ERRORLEVEL=%errorlevel%. Unable to enable SETLOCAL enableextensions.
        rem cmd /k /e:on /f:on /v:on md5build *
        GOTO :DONE
    )
    SETLOCAL ENABLEDELAYEDEXPANSION
    if errorlevel 1 (
        echo ERRORLEVEL=%errorlevel%. Unable to enable delayed variable expansion.
        GOTO :DONE
    )

    set RETURN=GOTO :EOF
    set BAT_ARGS=%*
    set BAT_ARG0=%0
    ::set BAT_CONFIG=dbof.config.txt
    :: you can't evaluate "/?" within a CALL or a FOR loop, so I check for the
    :: HELP switch here.
set md5_arg0=%0
set md5_arg0path=%~dp0
set md5_arg0name=%~n0
set md5_arg1=%1
set md5_arg1b=%md5_arg1:~0,1%
set md5_arg1c=%md5_arg1:~1,1%
set md5_arg2=%2
set md5_arg3=%3
set md5_arg4=%4
set md5_arg5=%5
set md5_quiet=false
set md5_subdir=false
set md5_listmode=false
set md5_listfilespec=*.*
set md5_outputfile=%cd%\md5.output.txt

set md5_newcmdline=
:CMDARGLOOP
    if {%1} equ {} goto :CMDARGDONE
    
    if /I {%1} equ {/L} (
      set md5_listmode=true
      shift
      goto :CMDARGLOOP
    ) 
    
    if /I {%1} equ {/Q} (
          set md5_quiet=true
          shift
          goto :CMDARGLOOP
    )
    
    if /I {%1} equ {/S} (
            set md5_subdir=true
            shift
            goto :CMDARGLOOP
    ) else (
            set md5_newcmdline=!md5_newcmdline! %1
            shift
            goto :CMDARGLOOP
    )
    
:CMDARGDONE
rem set md5
if /i {!md5_newcmdline!} equ {} (set md5_newcmdline=*.*)
if /i {!md5_newcmdline!} equ { } (set md5_newcmdline=*.*)

rem set md5
rem echo ][    ]!md5_newcmdline![
rem echo goto :MAIN !md5_newcmdline!
goto :MAIN !md5_newcmdline!
goto :DONE


:HELP
    @echo md5build.bat
    @echo.
    @echo Computes the MD5 hash for the specified files and stores the 
    @echo list of results into "md5.output.txt".  Afterward, it will
    @echo display the results (unless the /Q option
    @echo is used).  
    @echo.
    @echo Note: The title bar of the command window will
    @echo display which file is being processed along with the file size
    @echo to give you an idea for how long you have to wait.
    @echo Ignore "Invalid number..." error messages.  These are part of 
    @echo using very simplistic DOS integer math and croaks on numbers 
    @echo greater than 2GB.  Such errors will not effect the outcome.
    @echo.
    @echo Usage:
    @echo        md5build [/?]
    @echo        md5build [/Q]
    @echo        md5build [/Q] /S filespec  (not yet implemented)
    @echo        md5build [/Q] /L filespec  (not yet implemented)
    @echo        md5build [/Q] /F filespec  (not yet implemented)
    @echo.
    @echo    Command-line options:
    @echo          ^>  /?    Displays help instructions.
    @echo          ^>  /Q    Quiet/batch mode ^- Does not use pause
    @echo                     or Notepad for results.
    @echo          ^>  /S    Iterates subdirectories (using batch FOR loop)
    @echo          ^>  /L    List file mode - Gets the list of files from a
    @echo                     text file.  Each entry in the list file may
    @echo                     specify an ambiguous filespec.  For example:
    @echo                     *.v* on one line, and *.txt on another.
    @echo.
    @echo.
    @echo Examples:
    @echo        md5build 
    @echo                       Same as *.*.  Generates hash list for all
    @echo                       files in the current directory and displays 
    @echo                       the result.
    @echo.
    @echo        md5build  *.prn
    @echo                       Generates hash list for all *.prn files in the
    @echo                       current directory and does not display the 
    @echo                       result.
    @echo.
    @echo        md5build *.v*
    @echo                       Generates hash list for all *.v* files in the
    @echo                       current directory as well as all 
    @echo                       subdirectories and displays the results.
    @echo.
    @echo        md5build /S .
    @echo                       Generates hash list for all file in the current
    @echo                       directory, including subdirectories.
    @echo.
    @echo        md5build /L listfile*.txt
    @echo                       Useful if you have lots of different files with
    @echo                       spaces in the file or directory names.
    @echo                       Generates hash list for all files listed in
    @echo                       the list file (multiple list file may be 
    @echo                       on the command line). If the list files contain
    @echo                       directory names, you should include /S on the
    @echo                       command line arguments.
    @echo.
    @echo                       The format of the list file can look like this:
    @echo                           *.txt
    @echo                           dir1
    @echo                           dir2
    @echo                           file2
    @echo                           file3
goto :DONE

Note: MD5.EXE has a peculiar behavior when it comes to files with spaces and
when to use quotes around files or not.  For single files, it will accept 
quotes around a single file name as long as there are no wildcard characters
in the filename.  For example, *.v* will work for vmware disk files, but 
"*.v*" will not.


:DONE
