@echo off
	setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:SETUP

	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	
	!bat_pushecho!
	!bat_echolog! ========================================================================
	!bat_echolog! [!date! !time!] - !bat_batchfile! %*
	!bat_pushecho!
	
	set bat_submissiondir=!bat_exedir!\SubmissionFiles

	set bat_targetdir=
	if /i "%~1" neq "" (
		set bat_targetdir=\%~1
	)

	set bat_tempfile=!bat_exedir!\meteorcount.submission.txt
	set bat_tempfile2=!bat_exedir!\meteorcount.submission2.txt
	
	set bat_commentspace=                                                                               

goto :MAIN
	

:MAIN
	set /a bat_totalconfirmed=0
	
	echo.
	echo CAM Archived  Confirmed  Archived                  Confirmed              Ratio  Comments
	echo --- ------    ------     -------------------       -------------------    -----  ------------------------

	call :LOOP "ftpdetectinfo_*scanned.txt"
	call :LOOP "ftpdetectinfo.txt"
	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0


:LOOP
rem !bat_pushecho! [CALL !bat_batchfile!:LOOP] %*
!bat_push!
	set bat_detectfilespec=%~1

	set bat_targetpath=!bat_submissiondir!!bat_targetdir!
	
	dir "!bat_targetpath!\!bat_detectfilespec!" /s>nul 2>&1
	set bat_returncode=!errorlevel!
	if !bat_returncode! neq 0 (
		rem echo NOT FOUND - "!bat_targetpath!!bat_detectfilespec!"
		goto :LOOP_END
	)
	
		rem Loop through all the ".\SubmissionFiles\!bat_detectfilespec!" files
	rem echo 1    for /f "usebackq tokens=*" ..y in ^(`dir "!bat_targetpath!\!bat_detectfilespec!" /s/b /a-d^|sort /r^|find /i "EmailFiles"`^) do ...
	for /f "usebackq tokens=*" %%y in  (`dir "!bat_targetpath!\!bat_detectfilespec!" /s/b /a-d^|sort /r^|find /i "EmailFiles"`) do (
	    set bat_sourcedetectfull=
	    set bat_camera=

			rem Ensure that it isn't FTPdetectinfo_CaseHeader.txt, or
			rem FTPdetectinfo_Case001.txt, FTPdetectinfo_scanned_???_header.txt
	    echo.%%~y|find /i "_Case">nul:
	    if !errorlevel! equ 0 (
	    	rem Do not process if it is *_CaseHeader or *_Case00x
	    ) else (
	    	echo.%%~y|find /i "_header">nul:
	    	if !errorlevel! equ 0 (
	    		rem Do not process if it is *_CaseHeader or *_header
	    	) else (
				set bat_sourcedetectfull=%%y&	rem	Example: "C:\CAMS\SubmissionFiles\2012_05_19\213\EmailFiles\FTPdetectinfo_scanned-213.txt"
				set bat_detectfile_name=%%~nxy
rem !bat_echo! bat_sourcedetectfull=!bat_sourcedetectfull!

				rem echo 2 for /f "usebackq tokens=*" ..a in ^(`dir "!bat_sourcedetectfull!" /a-d /s/b^|sort /r`^) do ^(
				for            /f "usebackq tokens=*" %%a in  (`dir "!bat_sourcedetectfull!" /a-d /s/b^|sort /r`) do (
					set bat_msg= 
					set bat_camera=
					set bat_count1=000000
					set bat_count2=000000
					set bat_dirname=          
					set bat_dirname2=                   
					set bat_ratio=0:1 
					set bat_output=

					set bat_temp=%%~a

					set bat_fullpath=%%~a
					set bat_filename=%%~nxa
					set bat_path2=%%~dpa&			rem Remove everything but the filename ("\FTPdetectinfo*.txt")
					set bat_path=!bat_path2:~0,-1!
					call :PARSEDIR "!bat_path!"&	rem returns bat_dirname
					set bat_emaildir=!bat_path!::
					set bat_emaildir=!bat_emaildir:\::=!
					set bat_emaildir=!bat_emaildir:::=!

					if /i "!bat_dirname!" equ "EmailFiles" (
						set bat_filesize=%%~za

						call :LASTFROMPATH "!bat_path!"
						call :LASTFROMPATH "!bat_retval2!"
						set bat_camera=!bat_retval!
						if "!bat_camera:~4,1!" equ "_" (
rem !bat_echo! bat_camera=!bat_camera!
							rem It's an older dir in this format: 
							rem   C:\CAMS\SubmissionFiles\2012_08_11\EmailFiles\FTPdetectinfo_scanned.txt
							rem Also, bat_path=C:\CAMS\SubmissionFiles\2012_08_11\EmailFiles
							rem and   bat_retval2=C:\CAMS\SubmissionFiles


							rem Get the camera from some other means...
							for /f "usebackq tokens=*" %%y in (`dir "!bat_emaildir!\Cal-???" /b /ad /o-d`) do (
								set bat_camera_temp=%%y
								set bat_camera=!bat_camera_temp:~4,3!
							)

							set bat_cam=!bat_camera!
							call :LASTFROMPATH "!bat_retval2!"
							rem set bat_captureddate=!bat_retval!
							set bat_dirname=!bat_captureddate!
							rem set bat_dirname2=!bat_captureddate!
							set bat_dirname2=!bat_dirname!
rem !bat_echo! bat_fullpath=!bat_fullpath!
rem !bat_echo! bat_sourcedetectfull=!bat_sourcedetectfull!
rem !bat_echo! bat_retval=!bat_retval!
rem !bat_echo! bat_retval2=!bat_retval2!
rem !bat_echo! 1111 bat_dirname=!bat_dirname!
rem !bat_echo! bat_captureddate=!bat_captureddate!

						) else (
							set bat_cam=!bat_camera!
							call :LASTFROMPATH "!bat_retval2!"
							set bat_captureddate=!bat_retval!
							set bat_dirname=!bat_captureddate!
							set bat_dirname2=!bat_captureddate!
						
rem !bat_echo! bat_fullpath=!bat_fullpath!
rem !bat_echo! bat_sourcedetectfull=!bat_sourcedetectfull!
rem !bat_echo! bat_retval=!bat_retval!
rem !bat_echo! bat_retval2=!bat_retval2!
rem !bat_echo! 2222 bat_dirname=!bat_dirname!
rem !bat_echo! bat_captureddate=!bat_captureddate!
						)

						if /i "!bat_dirname:~4,1!" neq "_" (
							REM ERROR
						) else (
								rem bat_count1 is the returned count
							call :GETCOUNT "%%~a"
							set bat_count1=!bat_GC_count!


							if "!bat_count1!" equ "000000" (
								set output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
							) else (
								call :CONFIRMED "!bat_detectfile_name!"
								call :COMMENTS
							)& rem if "!bat_count1!" equ "000000"
						)
					)& rem if /i "!bat_dirname!" neq "EmailFiles"
				)
		    )
		)
	)
:LOOP_END

!bat_pop!
!bat_pop!
goto :EOF







:CONFIRMED
rem !bat_pushecho! [CALL !bat_batchfile!:CONFIRMED!] %*
!bat_push!
!bat_push!
				set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not
				set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!            !bat_dirname2!             !bat_ratio!  !bat_msg!



				set bat_detectfileconf=!bat_detectfile_name:_scanned=_confirmed!
rem !bat_echo! bat_detectfileconf=!bat_detectfileconf!
				if not exist "!bat_emaildir!\!bat_detectfileconf!" (
						set bat_detectfileconf=
				)
				
				if not defined bat_detectfileconf (
					echo !bat_output!
					set bat_msg=!bat_msg!; not confirmed
					goto :CONFIRM_END
				)

					rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
					rem Inside the loop, it will search for the bat_dirname in the resulting list.
				if not exist "!bat_emaildir!\!bat_detectfileconf!" (
					set bat_dirname2=                    
					set bat_msg=!bat_msg!; not confirmed
					set bat_count2=000000

					rem Loops to remove leading zeros
					for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
					for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

					if not defined bat_count1nz set bat_count1nz=0
					if not defined bat_count2nz set bat_count2nz=0

					rem logic to avoid divide by zero
					if "!bat_count2!" neq "000000" (
						set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
					) else (
						set /a bat_ratio=0
					)
					set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!          !bat_dirname2!    !bat_ratio!:1  !bat_msg!
					echo !bat_output!
				) else (
					rem echo 4   for /f "usebackq tokens=*" %%b in ^(`dir "!bat_path!\!bat_detectfileconf!" /s/b`^) do ^(
					for              /f "usebackq tokens=*" %%b in  (`dir "!bat_path!\!bat_detectfileconf!" /s/b`) do (
						rem To speed things up, skip if already found.
						if "!bat_found!" equ "0" (
							for /f "tokens=*" %%x in ("%%~b") do (
								set bat_temp=%%x
								set bat_detectconf=!bat_temp!
							)& rem for /f "tokens=*" %%x in


							call :GETCOUNT "!bat_path!\!bat_detectfileconf!"
							set bat_count2=!bat_GC_count!

							
		:STRIPZEROS
								rem Loops to remove leading zeros
							for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
							for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

							if not defined bat_count1nz set bat_count1nz=0
							if not defined bat_count2nz set bat_count2nz=0
						
							rem logic to avoid divide by zero
							if "!bat_count2!" neq "000000" (
								set /a bat_ratio=!bat_count1nz!^/!bat_count2nz!
								set /a bat_totalconfirmed+=!bat_count2nz!
							) else (
								set /a bat_ratio=0
							)& rem if "!bat_count2!" neq "000000"

							set bat_ratio=   !bat_ratio!
							set bat_ratio=!bat_ratio:~-3!

							if /i "!bat_msg!" equ " " (
								call :GETFIRSTCOMMENT
								set bat_msg=!bat_commentfirst!
							)

							set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!            !bat_dirname2!           !bat_ratio!:1    !bat_msg!
							echo !bat_output!
							
							call :GETCOMMENTS

						)& rem if "!bat_found!" equ "0"
					)&	rem end for /f "usebackq tokens=*" %%b in 
				)& rem if not exist "!bat_emaildir!\!bat_detectfileconf!"

				if "!bat_found!" equ 0 (
					echo "%%a" not yet confirmed.
				) else (
					rem
				)
	    	)& rem for /f "usebackq tokens=*" %%a in
	    )& rem if !errorlevel! neq 0

:CONFIRM_END
!bat_pop!
!bat_pop!
!bat_pop!
rem !bat_echolog! [RETURN !bat_batchfile!:CONFIRM] []
goto :EOF


:COMMENTS
	rem if not defined bat_detectfileconf (only do comments)
:COMMENTS_END
goto :EOF


	rem 
:GETDIRNAMES
	rem [in]bat_emaildir 
	rem [out]bat_captureddir 
	rem [out]bat_archiveddir 
	rem [out]bat_confirmeddir
	rem [out]bat_dirname
	rem [out]bat_dirname2
	
	
	set bat_GDN_temp=%~1&	rem path (e.g. "H:\CAMS\SubmissionFiles\2011_10_21\213\EmailFiles")
	
	rem Determine if dir format is...
	rem Either: CAMS\SubmissionFiles\2011_10_21\213\EmailFiles"
	rem     or: something else
	
	call :LASTFROMPATH "!bat_GDN_temp!"
	set bat_pathdate=!bat_retval2!

	rem get camera
	call :LASTFROMPATH "!bat_pathdate!"
	if "!bat_retval:~4,1!" equ "_" (
		set bat_datedir=!bat_retval!
		set bat_datedir2=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_datedir!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_datedir!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_datedir!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_datedir!
		
	)  else (
		set vers=2
		set bat_cam=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_cam!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_cam!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_cam!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_cam!
		
	)
	
	
	rem get dirname                    '
	set bat_dirname=                   
	set bat_dirname2=                   
	if exist "!bat_archiveddir!" (
		for /f "usebackq tokens=*" %%X in (`dir "!bat_archiveddir!" /b /o-n`) do (
			set bat_dirname=%%X
			set bat_dirname2=%%X
		)
	)
	

rem exit /b
goto :EOF



	rem extracts the last path segment
:LASTFROMPATH [in]path [out]bat_retval
!bat_push!
rem !bat_pushecho! [CALL !bat_batchfile!:LASTFROMPATH] %1
	set bat_junk=%~1::
	set bat_junk=!bat_junk:\::=!
	set bat_junk=!bat_junk:::=!
rem echo bat_junk=!bat_junk!
	for /f "usebackq tokens=*" %%X in ('!bat_junk!') do (
rem 		echo #######%%X$$$$$$$$$
rem 		echo #######!bat_junk!$$$$$$$$$
		set bat_retval=%%~nX
		set bat_retval2=%%~dpX::
		set bat_retval2=!bat_retval2:\::=!
		set bat_retval2=!bat_retval2:::=!
	)
:LASTFROMPATH_END
!bat_pop!
rem !bat_echolog! [RETURN !bat_batchfile!:LASTFROMPATH] [%1, !bat_retval2!, !bat_retval!]
!bat_return!




:GETFFFOLDER
	for /f "usebackq tokens=1-2 delims==" %%d in (`find /i "FF  folder" "!bat_path!!bat_filename!"`) do (
		set bat_fffolder=%%~e
		set bat_ffdate=!bat_fffolder:~-20!
		set bat_ffdate=!bat_ffdate:~0,10!
	)
goto :EOF




:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2


:PARSEDIR [in] bat_path=D:\CAMS\ArchivedFiles\2012_02_07_02_43_36
	set bat_dirname=%~nx1
:PARSEDIR_END
goto :EOF







:GETCOUNT [in] path\detectfile [out] bat_count1
rem echo call :GETCOUNT %*
	set bat_GC_detectfile=%~1
	
	rem Loop to extract the Meteor Count = value
	for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i "Meteor Count" "!bat_GC_detectfile!"`) do (
		set bat_temp=%%d
		set bat_GC_count=!bat_temp:~-6!
		if "!bat_GC_count!" equ "000000" (
			if "!bat_filesize!" GTR "480" (
				set bat_msg=; needs FTP_Reprocess
			)
		)
	)
:GETCOUNT_END
rem echo return-:GETCOUNT [!bat_GC_count!]
goto :EOF



:GETFIRSTCOMMENT
	set bat_commentsfile=comments_!bat_camera!.txt
	set bat_commentfirst=
	if not exist "!bat_emaildir!\!bat_commentsfile!" (
		set bat_commentsfile=comments.txt
		if not exist "!bat_emaildir!\!bat_commentsfile!" (
			goto :GETFIRSTCOMMENT_END
		)
	)
	
	set /a bat_commentline=0
	rem echo 2   for /f "usebackq tokens=*" %%f in ^(`type "!bat_emaildir!\!bat_commentsfile!"^) do ^(
	for /f "usebackq tokens=*" %%f in (`type "!bat_emaildir!\!bat_commentsfile!"`) do (
		set /a bat_commentline+=1
		if "!bat_commentline!" equ "1" (
			set bat_commentfirst=; %%f
		) else (
			rem
		)
	)
:GETFIRSTCOMMENT_END
rem echo :GETFIRSTCOMMENT_END
goto :EOF


:GETCOMMENTS
	set bat_commentsfile=comments_!bat_camera!.txt
	if not exist "!bat_emaildir!\!bat_commentsfile!" (
		set bat_commentsfile=comments.txt
		if not exist "!bat_emaildir!\!bat_commentsfile!" (
			goto :GETCOMMENTS_END
		)
	)
	
	set /a bat_commentline=0
	rem echo 3    for /f "usebackq tokens=*" %%f in ^(`type "!bat_emaildir!\!bat_commentsfile!"^) do ^(
	for /f "usebackq tokens=*" %%f in (`type "!bat_emaildir!\!bat_commentsfile!"`) do (
		set /a bat_commentline+=1
		if "!bat_commentline!" NEQ "1" (
			echo !bat_commentspace!%%f
		) else (
			rem
		)
	)
:GETCOMMENTS_END
rem echo :GETCOMMENTS_END
!bat_return!



:GETCAPTUREDTIME
:GETCAPTUREDTIME_END
!bat_return!


rem another option is this:
	findstr "CAL..._*" "C:\d\CAMS\SubmissionFiles\2012_05_23\213\EmailFiles\FTPdetectinfo_scanned-213.txt"

returns:
	CAL213_2012_05_23_055017_435.TXT
	CAL213_2012_05_23_055017_435.TXT
	CAL213_2012_05_23_055017_435.TXT

:HELP
	echo [%date% %time%] %~nx0 %* [submissiondir=!bat_submissiondir!] [targetdir=!bat_targetdir!]
	Usage 

exit /b 9

:DONE
