@echo off
	setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:SETUP
	
	call "AutoCams.setup.bat" "%~dpnx0"
	call "indent_setup.bat"
	
	
	!bat_pushecho!
	!bat_echolog! ========================================================================
	!bat_echolog! [!date! !time!] - !bat_batchfile! %*
	!bat_pushecho!

	set bat_targetdir=
	if /i "%~1" neq "" (
		set bat_targetdir=\%~1
	)

	set bat_submitteddir=!bat_exedir!\Submitted
	set bat_dirname_spaces=                                                

	set /a bat_totalconfirmed=0

:MAIN

rem	cls
	echo Archived  Confirmed  Archived                  Confirmed                Ratio  Comments
	echo ------    ------     ----------                ----------               -----  ------------------------

	if not exist "!bat_exedir!\ArchivedFiles" goto :ERR1
	if not exist "!bat_exedir!\ConfirmedFiles" goto :ERR2

	set bat_targetpath=!bat_submitteddir!!bat_targetdir!

	for /f "usebackq tokens=*" %%E in (`dir "!bat_targetpath!*" /ad /s/b /o-n`) do (
		set bat_targetpath=%%E

			rem Loop through all the "!bat_submitteddir!\FTPdetectinfo.txt" files
		rem !bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetpath!\ftpdetectinfo_*scanned.txt" /s/b /a-d /od`^) do ^(
		!bat_push!
		for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetpath!\ftpdetectinfo_*scanned.txt" /s/b /a-d /od`) do (
			set bat_msg= 
			rem Loop to extract the Meteor Count = value
			rem !bat_pushecho! for /f "usebackq tokens=1,2 delims=\=" ..c in ^(`find /i /n "Meteor Count" "%%a"`^) do ^(
			for /f "usebackq tokens=1,2 skip=2 delims=\=" %%c in (`find /i /n "Meteor Count" "%%a"`) do (
				set bat_temp=%%d
				set bat_count1=!bat_temp:~-6!
				if "!bat_count1!" equ "000000" (
					set bat_msg=; needs Detect
				)
			)
			rem !bat_popecho! ^) !bat_count1!*****!bat_msg!***

			set bat_temp=%%a
			set bat_tempdir=%%~dpa

			set bat_filename=%%~nxa

			rem echo "!bat_tempdir:~-11!", !bat_tempdir!

			set bat_path=%%~dpa&			rem get the path ("x:\cams\Submitted\[date/time]\EmailFiles
			set bat_emaildir=!bat_path!::
			set bat_emaildir=!bat_emaildir:\::=!
			set bat_emaildir=!bat_emaildir:::=!


			if /i "!bat_emaildir:~-10!" EQU "EmailFiles" (
				set bat_pathlefta=!bat_path:\EmailFiles\=!&rem remove the "\EmailFiles\", including trailing backslashes
				set bat_cameradir=!bat_pathlefta!

				for /f "tokens=*" %%b in ("!bat_cameradir!") do (
					set bat_pathdate=%%~dpb::
					set bat_pathdate=!bat_pathdate:\::=!
					set bat_pathdate=!bat_pathdate:::=!
					set bat_camera=%%~nxb
				)

				set bat_dirname=!bat_pathdate!&	rem Extract just the directory name (e.g. "2011_08_22_05_17_09")
				for /f "tokens=*" %%b in ("!bat_dirname!") do (
					set bat_pathdate=%%~dpb::
					set bat_pathdate=!bat_pathdate:\::=!
					set bat_pathdate=!bat_pathdate:::=!
					set bat_dirname=%%~nxb
				)
				set bat_dirname_out=!bat_dirname!!bat_dirname_spaces!
				set bat_dirname_out=!bat_dirname_out:~0,23!

				set bat_detectfileconf=!bat_filename:_scanned=_confirmed!

				set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not

rem echo temp       !bat_temp! 
rem echo path=      !bat_path!
rem echo emaildir   !bat_emaildir!
rem echo pathlefta= !bat_pathlefta!
rem echo cameradir= !bat_cameradir!
rem echo pathdate=  !bat_pathdate!
rem echo dirname=   !bat_dirname!
rem echo filename=  !bat_filename!
rem echo count=     !bat_count1!
rem echo camera=    !bat_camera!
rem echo detectconf=!bat_detectfileconf!

					rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
					rem Inside the loop, it will search for the bat_dirname in the resulting list.
				rem !bat_echo! if not exist "!bat_emaildir!\FTPdetectinfo_*confirmed.txt" ^(
				if not exist "!bat_emaildir!\!bat_detectfileconf!" (
				  rem !bat_echo! if not exist "!bat_emaildir!\!bat_detectfileconf!" ^(
					set bat_dirname2=                   
					set bat_msg=!bat_msg!; not confirmed
					set bat_count2=000000

					rem Loops to remove leading zeros
					for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
					for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

					if not defined bat_count1nz set bat_count1nz=0
					if not defined bat_count2nz set bat_count2nz=0

						rem logic to avoid divide by zero
					if "!bat_count2!" neq "000000" (
						rem set bat_count
						rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
						set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
					) else (
						set /a bat_ratio=0
					)

					set bat_output=!bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!        !bat_ratio!:1 !bat_msg!

					call :DOCOMMENTS

					set bat_output=!bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!        !bat_ratio!:1 !bat_msg!

				) else (

					for /f "usebackq tokens=*" %%b in (`dir "!bat_emaildir!\!bat_detectfileconf!" /s/b`) do (
						rem To speed things up, skip if already found.
						if "!bat_found!" equ "0" (
							set bat_temp=%%b
							set bat_file2=%%~nxb
							set bat_path2=%%~dpb!::&	rem Extract everything but the filename ("\FTPdetectinfo.txt")
							set bat_path2=!bat_path2:\::=!
							set bat_path2=!bat_path2:::=!

							set bat_dirname2=!bat_dirname!
							set bat_dirname2_out=!bat_dirname_out!

		rem echo dirname2	!bat_dirname2!


							if "!bat_dirname!" equ "!bat_dirname2!" (
								set bat_found=1
								for /f "usebackq tokens=1,2 skip=2 delims=\=" %%c in (`find /i /n "meteor count" "%%b"`) do (
									set bat_temp=%%d
									set bat_count2=!bat_temp:~-6!
								)

		:STRIPZEROS
								rem Loops to remove leading zeros
								for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
								for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

								if not defined bat_count1nz set bat_count1nz=0
								if not defined bat_count2nz set bat_count2nz=0

								rem logic to avoid divide by zero
								if "!bat_count2!" neq "000000" (
									rem set bat_count
									rem echo set /a bat_ratio=!bat_count1nz!/!bat_count2nz!
									set /a bat_ratio=!bat_count1nz!^/!bat_count2nz!
									set /a bat_totalconfirmed+=!bat_count2nz!
									rem echo !bat_totalconfirmed!
								) else (
									set /a bat_ratio=0
								)

								set bat_ratio=   !bat_ratio!
								set bat_ratio=!bat_ratio:~-3!

								rem echo !bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!    !bat_ratio!:1 !bat_msg!
								set bat_output=!bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!  !bat_ratio!:1 !bat_msg!

								call :DOCOMMENTS
							)
						)
					)&	rem end for /f ... %%b
				)


				set bat_comments=!bat_path2!\EmailFiles\comments*.txt

				rem append the text in comments.txt to bat_msg
				if exist "!bat_comments!" (
					for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
						set bat_msg=!bat_msg!; %%f
					)
				)

				rem echo !bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!    !bat_ratio!:1 !bat_msg!

				if "!bat_found!" equ 0 (
					echo "%%a" not yet confirmed.
				) else (
					rem
				)
			) else (
				rem echo NOT AN EMAILFILES DIR
			)


		)&	rem end for /f ... %%a
	rem 	!bat_popecho! ^)
	)

	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0




:DOCOMMENTS
rem !bat_pushecho! [CALL !bat_batchfile!:DOCOMMENTS] %*
	set bat_comments=!bat_emaildir!\comments*.txt
	set bat_commentspace=                                                                                 

	rem append the text in comments.txt to bat_msg
	if exist "!bat_comments!" (
		for /f "usebackq tokens=*" %%f in (`dir "!bat_comments!" /s/b`) do (
			set bat_comments=%%f
		)

		for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
			if "!bat_msg!" equ " " (
				set bat_msg=; %%f
				set bat_output=!bat_output!!bat_msg!
				echo !bat_output!
			) else (
				if "!bat_msg!" equ "; needs Detect" (
					set bat_msg=; %%f
					set bat_output=!bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!        !bat_ratio!:1 !bat_msg!
					echo !bat_output!
				) else (
					if "!bat_msg!" equ "; not confirmed" (
						set bat_output=!bat_count1!    !bat_count2!     !bat_dirname_out!   !bat_dirname2_out!        !bat_ratio!:1 !bat_msg!
						echo !bat_output!
						echo !bat_commentspace!%%f
					) else (
						echo !bat_commentspace!%%f
					)
				)
			)
		)
		rem echo.
	) else (
		echo !bat_output!
		set bat_comments=
	)


:DOCOMMENTS_END
rem !bat_popecho! [RETURN !bat_batchfile!:DOCOMMENTS] [!bat_comments!]
rem !bat_echolog!                                     [!bat_emaildir!\!bat_filename!]
rem !bat_echolog!
!bat_return!





:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2


:HELP
exit /b 9

